TOOL.AddToMenu		= true
TOOL.Category		= "Kogitsune's Toybox"
TOOL.Name		= "Player Resizer - Simple"
TOOL.Command		= nil
TOOL.ConfigName		= nil

TOOL.ClientConVar[ "size" ] = 1
TOOL.ClientConVar[ "adju" ] = 1

if CLIENT then
	language.Add( "Tool_resize_name"	, "Player Resizer" 												)
	language.Add( "Tool_resize_desc"	, "Resize a player!" 												)
	language.Add( "Tool_resize_0"		, "Left Click to resize, right to set your own, reload to reset yourself, or the player you are looking at." 	)
end

function TOOL:LeftClick( trace )
	local a, b
	
	a = math.Clamp( self:GetClientNumber( "size" ), .16, 16 ) * Vector( )
	b = self:GetClientNumber( "adju" ) ~= 0
		
	pl = trace.Entity
	
	if not pl:IsPlayer( ) then
		return false
	end
	
	PrepPlayer( pl, a,  	VecMul( Sizing.Hulls.Standing.Minimum, a ), 
				VecMul( Sizing.Hulls.Standing.Maximum, a ), 
				VecMul( Sizing.Hulls.Ducking.Minimum , a ),
				VecMul( Sizing.Hulls.Ducking.Maximum , a ),
				Sizing.Variables.JumpPower * a.z * 72 * ( a.z < .5 and 2 or 1 ), Sizing.Variables.StepSize * 72 * a.z, Sizing.Variables.RunSpeed * 72 * a.z, Sizing.Variables.WalkSpeed * 72 * a.z,
				Vector( 0, 0, a.z * 64 ), Vector( 0, 0, a.z * 28 ), b )		
	return true
end

function TOOL:RightClick( trace )
	return self:LeftClick{ Entity = self:GetOwner( ) }
end

function TOOL:Reload( trace )
	local pl, a
	
	if ValidEntity( trace.Entity ) and trace.Entity:IsPlayer( ) then
		pl = trace.Entity
	else
		pl = self:GetOwner( )
	end
	
	pl:ResetHull( )
	pl:SetViewOffset( 	Vector( 0, 0, Sizing.Offsets.Standing * 72 	) )
	pl:SetViewOffsetDucked( Vector( 0, 0, Sizing.Offsets.Ducking * 36 	) )
	pl:SetStepSize( Sizing.Variables.StepSize * 72 )
	pl:SetJumpPower( Sizing.Variables.JumpPower * 36 )
	
	a = Vector( )
	
	gamemode.Call( "SetPlayerSpeed", pl, Sizing.Variables.WalkSpeed * 72, Sizing.Variables.RunSpeed * 72 )
	
	PrepPlayer( pl, a, VecMul( Sizing.Hulls.Standing.Minimum, a ), 
				VecMul( Sizing.Hulls.Standing.Maximum, a ), 
				VecMul( Sizing.Hulls.Ducking.Minimum , a ),
				VecMul( Sizing.Hulls.Ducking.Maximum , a ),
				Sizing.Variables.JumpPower * 72, Sizing.Variables.StepSize * 72, Sizing.Variables.RunSpeed * 72, Sizing.Variables.WalkSpeed * 72,
				Vector( 0, 0, 64 ), Vector( 0, 0, 28 ), true )	
end

function TOOL.BuildCPanel( panel )
	panel:AddControl( "Header", { Text = "#Tool_resize_name" } )
	panel:AddControl( "Slider", { Label = "Size", Type = "Float", Min = .16, Max = 16, Command = "resize_size" } )
	panel:AddControl( "Checkbox", { Label = "Adjust movement to height?", Command = "resize_adju" } )
end